package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btn3 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _pnl1 = null;
public anywheresoftware.b4a.objects.collections.List _lstlog = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _sv1 = null;
public static String _tstart = "";
public static String _tstop = "";
public static int _cnt = 0;
public static int _idx = 0;
public static String _txt1 = "";
public static String _txt2 = "";
public showlist _showlist = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 40;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 43;BA.debugLine="Activity.LoadLayout(\"LogTest\")";
mostCurrent._activity.LoadLayout("LogTest",mostCurrent.activityBA);
 //BA.debugLineNum = 44;BA.debugLine="Init";
_init();
 //BA.debugLineNum = 46;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 52;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 54;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 48;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _btn_click() throws Exception{
anywheresoftware.b4a.objects.ButtonWrapper _getbtn = null;
String _isnow = "";
 //BA.debugLineNum = 80;BA.debugLine="Sub btn_Click";
 //BA.debugLineNum = 81;BA.debugLine="Dim GetBtn As  Button 'Holds which button has been tapped.";
_getbtn = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 82;BA.debugLine="Dim IsNow As String 'Holds the current time";
_isnow = "";
 //BA.debugLineNum = 85;BA.debugLine="IsNow = DateTime.Time(DateTime.Now)";
_isnow = anywheresoftware.b4a.keywords.Common.DateTime.Time(anywheresoftware.b4a.keywords.Common.DateTime.getNow());
 //BA.debugLineNum = 88;BA.debugLine="GetBtn = Sender";
_getbtn.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 91;BA.debugLine="Select GetBtn.Tag";
switch (BA.switchObjectToInt(_getbtn.getTag(),(Object)("1"),(Object)("2"),(Object)("3"),(Object)("4"))) {
case 0:
 //BA.debugLineNum = 93;BA.debugLine="Txt2 = Txt2 & \"{Green}{I}{B}\" & IsNow & \" -- Start Time.\" & \"{B}{I}{Green}\" & CRLF";
mostCurrent._txt2 = mostCurrent._txt2+"{Green}{I}{B}"+_isnow+" -- Start Time."+"{B}{I}{Green}"+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 94;BA.debugLine="If Idx = 0 Then 'Starts the log on the first \"Start\" press.";
if (_idx==0) { 
 //BA.debugLineNum = 95;BA.debugLine="Txt2 = \"{B}--- BEGIN LOG for \" & DateTime.Date(DateTime.Now) & \" ---{B}\" & CRLF & Txt2";
mostCurrent._txt2 = "{B}--- BEGIN LOG for "+anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow())+" ---{B}"+anywheresoftware.b4a.keywords.Common.CRLF+mostCurrent._txt2;
 //BA.debugLineNum = 96;BA.debugLine="Idx = Idx + 1 'Increment counter flag.";
_idx = (int)(_idx+1);
 };
 break;
case 1:
 //BA.debugLineNum = 99;BA.debugLine="Txt2 = Txt2 & \"{Red}{B}\" & IsNow & \" -- Stop Time.\" & \"{B}{Red}\" & CRLF";
mostCurrent._txt2 = mostCurrent._txt2+"{Red}{B}"+_isnow+" -- Stop Time."+"{B}{Red}"+anywheresoftware.b4a.keywords.Common.CRLF;
 break;
case 2:
 //BA.debugLineNum = 101;BA.debugLine="Txt1 = Txt1 & Txt2";
mostCurrent._txt1 = mostCurrent._txt1+mostCurrent._txt2;
 //BA.debugLineNum = 102;BA.debugLine="File.WriteString(File.DirRootExternal, \"Log.txt\", Txt1)";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"Log.txt",mostCurrent._txt1);
 //BA.debugLineNum = 103;BA.debugLine="StartActivity(ShowLIst)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._showlist.getObject()));
 break;
case 3:
 //BA.debugLineNum = 106;BA.debugLine="If Txt2 <> \"\" Then";
if ((mostCurrent._txt2).equals("") == false) { 
 //BA.debugLineNum = 107;BA.debugLine="Txt2 = Txt2 & \"{B}--- END LOG for \" & DateTime.Date(DateTime.Now) & \" ---{B}\" & CRLF & CRLF";
mostCurrent._txt2 = mostCurrent._txt2+"{B}--- END LOG for "+anywheresoftware.b4a.keywords.Common.DateTime.Date(anywheresoftware.b4a.keywords.Common.DateTime.getNow())+" ---{B}"+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF;
 };
 //BA.debugLineNum = 110;BA.debugLine="Txt1 = Txt1 & Txt2";
mostCurrent._txt1 = mostCurrent._txt1+mostCurrent._txt2;
 //BA.debugLineNum = 111;BA.debugLine="File.WriteString(File.DirRootExternal, \"Log.txt\", Txt1)";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"Log.txt",mostCurrent._txt1);
 //BA.debugLineNum = 112;BA.debugLine="Idx = 0";
_idx = (int)(0);
 //BA.debugLineNum = 113;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 break;
}
;
 //BA.debugLineNum = 115;BA.debugLine="GetRS(Txt2)";
_getrs(mostCurrent._txt2);
 //BA.debugLineNum = 117;BA.debugLine="End Sub";
return "";
}
public static String  _getrs(String _txtin) throws Exception{
String _txtout = "";
int _ht = 0;
anywheresoftware.b4a.objects.StringUtils _su = null;
anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichString _rs = null;
anywheresoftware.b4a.agraham.richstring.RichStringBuilder _rsb = null;
anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichStringFormatter _rsf = null;
 //BA.debugLineNum = 120;BA.debugLine="Sub GetRS (TxtIn As String)";
 //BA.debugLineNum = 121;BA.debugLine="Dim TxtOut As String";
_txtout = "";
 //BA.debugLineNum = 122;BA.debugLine="Dim Ht As Int";
_ht = 0;
 //BA.debugLineNum = 123;BA.debugLine="Dim SU As StringUtils";
_su = new anywheresoftware.b4a.objects.StringUtils();
 //BA.debugLineNum = 124;BA.debugLine="Dim rs As RichString";
_rs = new anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichString();
 //BA.debugLineNum = 125;BA.debugLine="Dim rsb As RichStringBuilder";
_rsb = new anywheresoftware.b4a.agraham.richstring.RichStringBuilder();
 //BA.debugLineNum = 126;BA.debugLine="Dim rsf As RichStringFormatter";
_rsf = new anywheresoftware.b4a.agraham.richstring.RichStringBuilder.RichStringFormatter();
 //BA.debugLineNum = 129;BA.debugLine="rsf.Initialize(\"{sample}\")";
_rsf.Initialize("{sample}");
 //BA.debugLineNum = 132;BA.debugLine="rsf.AddToken(\"{Green}\", rsf.FORMAT_COLOR, Colors.Green)";
_rsf.AddToken("{Green}",_rsf.FORMAT_COLOR,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Green));
 //BA.debugLineNum = 133;BA.debugLine="rsf.AddToken(\"{Red}\", rsf.FORMAT_COLOR, Colors.Red)";
_rsf.AddToken("{Red}",_rsf.FORMAT_COLOR,BA.NumberToString(anywheresoftware.b4a.keywords.Common.Colors.Red));
 //BA.debugLineNum = 134;BA.debugLine="rsf.AddToken(\"{I}\", rsf.FORMAT_STYLE, rsf.STYLE_ITALIC)";
_rsf.AddToken("{I}",_rsf.FORMAT_STYLE,BA.NumberToString(_rsf.STYLE_ITALIC));
 //BA.debugLineNum = 135;BA.debugLine="rsf.AddToken(\"{B}\", rsf.FORMAT_STYLE, rsf.STYLE_BOLD)";
_rsf.AddToken("{B}",_rsf.FORMAT_STYLE,BA.NumberToString(_rsf.STYLE_BOLD));
 //BA.debugLineNum = 138;BA.debugLine="rs.Initialize(\"\")";
_rs.Initialize((java.lang.CharSequence)(""));
 //BA.debugLineNum = 139;BA.debugLine="rs.Initialize(TxtIn)";
_rs.Initialize((java.lang.CharSequence)(_txtin));
 //BA.debugLineNum = 142;BA.debugLine="rs = rsf.Format(rs)";
_rs = _rsf.Format((android.text.SpannableString)(_rs.getObject()));
 //BA.debugLineNum = 145;BA.debugLine="lbl1.Text = rs";
mostCurrent._lbl1.setText((Object)(_rs.getObject()));
 //BA.debugLineNum = 146;BA.debugLine="Ht = SU.MeasureMultilineTextHeight(lbl1, lbl1.Text) 'Measure the height of the label text.";
_ht = _su.MeasureMultilineTextHeight((android.widget.TextView)(mostCurrent._lbl1.getObject()),mostCurrent._lbl1.getText());
 //BA.debugLineNum = 147;BA.debugLine="If Ht > sv1.Panel.Height Then";
if (_ht>mostCurrent._sv1.getPanel().getHeight()) { 
 //BA.debugLineNum = 148;BA.debugLine="sv1.Panel.Height = Ht + 48";
mostCurrent._sv1.getPanel().setHeight((int)(_ht+48));
 //BA.debugLineNum = 149;BA.debugLine="lbl1.Height = sv1.Panel.Height";
mostCurrent._lbl1.setHeight(mostCurrent._sv1.getPanel().getHeight());
 };
 //BA.debugLineNum = 152;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
showlist._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
vis = vis | (showlist.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 25;BA.debugLine="Dim btn1 As Button 'Start tiime button";
mostCurrent._btn1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 26;BA.debugLine="Dim btn2 As Button 'Stop time button";
mostCurrent._btn2 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim btn3 As Button 'Terminates the app.";
mostCurrent._btn3 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim lbl1 As Label 'Displays the time stamps as they occur.";
mostCurrent._lbl1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim pnl1 As Panel 'Holds the other views.";
mostCurrent._pnl1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim lstLog As List 'Stores the time stamps";
mostCurrent._lstlog = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 33;BA.debugLine="Dim sv1 As ScrollView";
mostCurrent._sv1 = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Dim TStart, TStop As String 'Holds start and stop times.";
mostCurrent._tstart = "";
mostCurrent._tstop = "";
 //BA.debugLineNum = 35;BA.debugLine="Dim Cnt, Idx As Int 'Counters.  Start at 0.";
_cnt = 0;
_idx = 0;
 //BA.debugLineNum = 36;BA.debugLine="Dim Txt1, Txt2 As String 'The file and the text to be displayed and added to the list.";
mostCurrent._txt1 = "";
mostCurrent._txt2 = "";
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _init() throws Exception{
 //BA.debugLineNum = 56;BA.debugLine="Sub Init";
 //BA.debugLineNum = 57;BA.debugLine="Activity.TitleColor = Colors.White";
mostCurrent._activity.setTitleColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 58;BA.debugLine="Activity.Title = \"Log Record Test\"";
mostCurrent._activity.setTitle((Object)("Log Record Test"));
 //BA.debugLineNum = 59;BA.debugLine="lstLog.Initialize 'Create an empty list.";
mostCurrent._lstlog.Initialize();
 //BA.debugLineNum = 60;BA.debugLine="lbl1.Initialize(\"\") 'Prepare to add the Label to the scrollview panel.";
mostCurrent._lbl1.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 61;BA.debugLine="lbl1.TextColor = Colors.Black";
mostCurrent._lbl1.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 62;BA.debugLine="pnl1.Color = Colors.Black";
mostCurrent._pnl1.setColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 64;BA.debugLine="sv1.Panel.Width = sv1.Width";
mostCurrent._sv1.getPanel().setWidth(mostCurrent._sv1.getWidth());
 //BA.debugLineNum = 65;BA.debugLine="sv1.Panel.Height = sv1.Height";
mostCurrent._sv1.getPanel().setHeight(mostCurrent._sv1.getHeight());
 //BA.debugLineNum = 66;BA.debugLine="sv1.Color = Colors.White";
mostCurrent._sv1.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 67;BA.debugLine="sv1.Panel.Color = Colors.White";
mostCurrent._sv1.getPanel().setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 69;BA.debugLine="sv1.Panel.AddView(lbl1, sv1.Left + 10, sv1.Top, sv1.Width - 20, sv1.Height)";
mostCurrent._sv1.getPanel().AddView((android.view.View)(mostCurrent._lbl1.getObject()),(int)(mostCurrent._sv1.getLeft()+10),mostCurrent._sv1.getTop(),(int)(mostCurrent._sv1.getWidth()-20),mostCurrent._sv1.getHeight());
 //BA.debugLineNum = 70;BA.debugLine="Cnt = 0 'Initialize the list counter.";
_cnt = (int)(0);
 //BA.debugLineNum = 71;BA.debugLine="Idx = 0 'Indicates whether the first time \"Start\" is pressed.";
_idx = (int)(0);
 //BA.debugLineNum = 72;BA.debugLine="If File.Exists(File.DirRootExternal, \"Log.txt\") = False Then";
if (anywheresoftware.b4a.keywords.Common.File.Exists(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"Log.txt")==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 73;BA.debugLine="File.WriteString(File.DirRootExternal, \"Log.txt\", \"{Red}{B}{I}*** LOG FILE ***{I}{B}{Red}\" & CRLF & CRLF)";
anywheresoftware.b4a.keywords.Common.File.WriteString(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"Log.txt","{Red}{B}{I}*** LOG FILE ***{I}{B}{Red}"+anywheresoftware.b4a.keywords.Common.CRLF+anywheresoftware.b4a.keywords.Common.CRLF);
 };
 //BA.debugLineNum = 76;BA.debugLine="Txt1 = File.ReadString(File.DirRootExternal, \"Log.txt\")";
mostCurrent._txt1 = anywheresoftware.b4a.keywords.Common.File.ReadString(anywheresoftware.b4a.keywords.Common.File.getDirRootExternal(),"Log.txt");
 //BA.debugLineNum = 78;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
}
